<a id="mypy-boto3-dataexchange"></a>

# mypy-boto3-dataexchange

[![PyPI - types-aiobotocore-dataexchange](https://img.shields.io/pypi/v/types-aiobotocore-dataexchange.svg?color=blue)](https://pypi.org/project/types-aiobotocore-dataexchange)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-dataexchange.svg?color=blue)](https://pypi.org/project/types-aiobotocore-dataexchange)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-dataexchange?color=blue)](https://pypistats.org/packages/types-aiobotocore-dataexchange)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.DataExchange 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/dataexchange.html#DataExchange)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-dataexchange docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_dataexchange/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-dataexchange](#mypy-boto3-dataexchange)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `DataExchange`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `DataExchange` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[dataexchange]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[dataexchange]'

# standalone installation
python -m pip install types-aiobotocore-dataexchange
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[dataexchange]` in your environment:
  `python -m pip install 'types-aiobotocore[dataexchange]'`

Both type checking and auto-complete should work for `DataExchange` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[dataexchange]` in your environment:
  `python -m pip install 'types-aiobotocore[dataexchange]'`

Both type checking and auto-complete should work for `DataExchange` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[dataexchange]` in your environment:
  `python -m pip install 'types-aiobotocore[dataexchange]'`
- Run `mypy` as usual

Type checking should work for `DataExchange` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[dataexchange]` in your environment:
  `python -m pip install 'types-aiobotocore[dataexchange]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `DataExchange` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`DataExchangeClient` provides annotations for
`session.create_client("dataexchange")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_dataexchange import DataExchangeClient

session = get_session()
async with session.create_client("dataexchange") as client:
    client: DataExchangeClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_dataexchange.paginator` module contains type annotations for
all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_dataexchange import DataExchangeClient
from types_aiobotocore_dataexchange.paginator import (
    ListDataSetRevisionsPaginator,
    ListDataSetsPaginator,
    ListEventActionsPaginator,
    ListJobsPaginator,
    ListRevisionAssetsPaginator,
)

session = get_session()
async with session.create_client("dataexchange") as client:
    client: DataExchangeClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_data_set_revisions_paginator: ListDataSetRevisionsPaginator = client.get_paginator("list_data_set_revisions")
        list_data_sets_paginator: ListDataSetsPaginator = client.get_paginator("list_data_sets")
        list_event_actions_paginator: ListEventActionsPaginator = client.get_paginator("list_event_actions")
        list_jobs_paginator: ListJobsPaginator = client.get_paginator("list_jobs")
        list_revision_assets_paginator: ListRevisionAssetsPaginator = client.get_paginator("list_revision_assets")
    ```







### Literals

`types_aiobotocore_dataexchange.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_dataexchange.literals import (
    AssetTypeType,
    CodeType,
    JobErrorLimitNameType,
    JobErrorResourceTypesType,
    ListDataSetRevisionsPaginatorName,
    ListDataSetsPaginatorName,
    ListEventActionsPaginatorName,
    ListJobsPaginatorName,
    ListRevisionAssetsPaginatorName,
    OriginType,
    ProtocolTypeType,
    ServerSideEncryptionTypesType,
    StateType,
    TypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: AssetTypeType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_dataexchange.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_dataexchange.type_defs import (
    ActionTypeDef,
    ApiGatewayApiAssetTypeDef,
    AssetDestinationEntryTypeDef,
    AssetDetailsTypeDef,
    AssetEntryTypeDef,
    AssetSourceEntryTypeDef,
    AutoExportRevisionDestinationEntryTypeDef,
    AutoExportRevisionToS3RequestDetailsTypeDef,
    CancelJobRequestRequestTypeDef,
    CreateDataSetRequestRequestTypeDef,
    CreateDataSetResponseTypeDef,
    CreateEventActionRequestRequestTypeDef,
    CreateEventActionResponseTypeDef,
    CreateJobRequestRequestTypeDef,
    CreateJobResponseTypeDef,
    CreateRevisionRequestRequestTypeDef,
    CreateRevisionResponseTypeDef,
    DataSetEntryTypeDef,
    DeleteAssetRequestRequestTypeDef,
    DeleteDataSetRequestRequestTypeDef,
    DeleteEventActionRequestRequestTypeDef,
    DeleteRevisionRequestRequestTypeDef,
    DetailsTypeDef,
    EventActionEntryTypeDef,
    EventTypeDef,
    ExportAssetToSignedUrlRequestDetailsTypeDef,
    ExportAssetToSignedUrlResponseDetailsTypeDef,
    ExportAssetsToS3RequestDetailsTypeDef,
    ExportAssetsToS3ResponseDetailsTypeDef,
    ExportRevisionsToS3RequestDetailsTypeDef,
    ExportRevisionsToS3ResponseDetailsTypeDef,
    ExportServerSideEncryptionTypeDef,
    GetAssetRequestRequestTypeDef,
    GetAssetResponseTypeDef,
    GetDataSetRequestRequestTypeDef,
    GetDataSetResponseTypeDef,
    GetEventActionRequestRequestTypeDef,
    GetEventActionResponseTypeDef,
    GetJobRequestRequestTypeDef,
    GetJobResponseTypeDef,
    GetRevisionRequestRequestTypeDef,
    GetRevisionResponseTypeDef,
    ImportAssetFromApiGatewayApiRequestDetailsTypeDef,
    ImportAssetFromApiGatewayApiResponseDetailsTypeDef,
    ImportAssetFromSignedUrlJobErrorDetailsTypeDef,
    ImportAssetFromSignedUrlRequestDetailsTypeDef,
    ImportAssetFromSignedUrlResponseDetailsTypeDef,
    ImportAssetsFromRedshiftDataSharesRequestDetailsTypeDef,
    ImportAssetsFromRedshiftDataSharesResponseDetailsTypeDef,
    ImportAssetsFromS3RequestDetailsTypeDef,
    ImportAssetsFromS3ResponseDetailsTypeDef,
    JobEntryTypeDef,
    JobErrorTypeDef,
    ListDataSetRevisionsRequestRequestTypeDef,
    ListDataSetRevisionsResponseTypeDef,
    ListDataSetsRequestRequestTypeDef,
    ListDataSetsResponseTypeDef,
    ListEventActionsRequestRequestTypeDef,
    ListEventActionsResponseTypeDef,
    ListJobsRequestRequestTypeDef,
    ListJobsResponseTypeDef,
    ListRevisionAssetsRequestRequestTypeDef,
    ListRevisionAssetsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    OriginDetailsTypeDef,
    PaginatorConfigTypeDef,
    RedshiftDataShareAssetSourceEntryTypeDef,
    RedshiftDataShareAssetTypeDef,
    RequestDetailsTypeDef,
    ResponseDetailsTypeDef,
    ResponseMetadataTypeDef,
    RevisionDestinationEntryTypeDef,
    RevisionEntryTypeDef,
    RevisionPublishedTypeDef,
    S3SnapshotAssetTypeDef,
    SendApiAssetRequestRequestTypeDef,
    SendApiAssetResponseTypeDef,
    StartJobRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAssetRequestRequestTypeDef,
    UpdateAssetResponseTypeDef,
    UpdateDataSetRequestRequestTypeDef,
    UpdateDataSetResponseTypeDef,
    UpdateEventActionRequestRequestTypeDef,
    UpdateEventActionResponseTypeDef,
    UpdateRevisionRequestRequestTypeDef,
    UpdateRevisionResponseTypeDef,
)

def get_structure() -> ActionTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-dataexchange` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-dataexchange docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_dataexchange/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
